<h3>Overview</h3>
<p>Security vulnerabilities pose significant threats. Understanding these vulnerabilities is crucial in software development. This section of the course focuses on common vulnerabilities in Python and JavaScript, as those are the most used languages in the community.</p>
<p>By the end of the course, you will have a basic understanding of the most probable vulnerabilities in the code we work with, so you can look out for and prevent them from being merged. The goal is not to be a security expert, but at least to be able to recognize common issues.</p>
<p>Throughout the course, you will face with basic challenges (and solutions to them), so you can learn while having fun. However, the code provided for demonstration is not from the Open edX code base. </p>
<h3>Downloadable resources</h3>
<p style="font-size: 16px;">At the end of the actionable units, you will find a link to download the resources (from our Google Drive). None of the examples will contain harmful code, so feel free to run them in your working environment. Every resource will have a README, so you know what to expect case by case.</p>
<h3>CVE and Vulnerabilities</h3>
<p>Let's start with the basic terms and definitions, so everyone is on the same page when talking about vulnerabilities.</p>
<blockquote>
<p>A security vulnerability is a weakness or flaw in a system that can be exploited by an attacker to gain unauthorized access or perform unauthorized actions. Vulnerabilities can arise from various sources, including coding errors, design flaws, misconfigurations, and unpatched software.</p>
</blockquote>
<p>The impact of a vulnerability can range from minor disruptions to severe breaches, leading to data loss, financial damage, and reputational harm. Often, specific vulnerabilities are identified by CVE (Common Vulnerabilities and Exposures) numbers and tracked in databases, like <a href="https://www.exploit-db.com/" title="Exploit DB" target="_blank" rel="noopener">Exploit DB</a>, <a href="https://vulners.com/" title="Vulners" target="_blank" rel="noopener">Vulners</a>, or <a href="https://www.cvedetails.com/" title="CVE Details" target="_blank" rel="noopener">CVE Details</a>. Not all databases have the same CVEs, so if looking for a CVE, it is worth checking across several DBs. The Open edX project is tracking its <strong>public vulnerabilities</strong> on <a href="https://github.com/openedx/edx-platform/security" title="Vulnerability list" target="_blank" rel="noopener">GitHub</a> related to the corresponding repository, though not every vulnerability is “officially reported”, so may not have a CVE ID.</p>
<p>Over the course, we will face with numerous terms. These terms will be explained in place to help you understand them in context.</p>